﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel.Activities.Activation;
using System.ServiceModel.Activities;
using System.ServiceModel.Activities.Description;
using System.Configuration;
using System.ServiceModel;

namespace TakeThatWF.Infrastructure
{
    public class TakeThatWFServiceHostFactory : WorkflowServiceHostFactory
    {



        //uncommenting this somehow broke the app. Need to figure out why!
        //public override ServiceHostBase CreateServiceHost(string constructorString, Uri[] baseAddresses)
        //{
        //    ServiceHostBase host = base.CreateServiceHost(constructorString, baseAddresses);
        //    ConfigureServiceHost(host);
        //    return host;
        //}

        protected override WorkflowServiceHost CreateWorkflowServiceHost(System.Activities.Activity activity, Uri[] baseAddresses)
        {
            WorkflowServiceHost host = base.CreateWorkflowServiceHost(activity, baseAddresses);
            ConfigureServiceHost(host);
            return host;

        }

        protected override WorkflowServiceHost CreateWorkflowServiceHost(WorkflowService service, Uri[] baseAddresses)
        {
            var host = base.CreateWorkflowServiceHost(service, baseAddresses);
            ConfigureServiceHost(host);
            return host;

        }

        private void ConfigureServiceHost(ServiceHostBase host)
        {
            
            // Note: in this scenario we're using an HTTP based basic binding and are assuming that no end points have been previously defined
            // if you need more details on this wiring, leave me a message and I will put up a post explaining all this.
            // It would also be possible to use other bindings if required.
            var customEndpoint = new TakeThatWF.Infrastructure.CustomEndPoint(
                new BasicHttpBinding(),
                new EndpointAddress(host.BaseAddresses[0]));
            host.AddServiceEndpoint(customEndpoint);

            CustomiseWorkflowHost(host as WorkflowServiceHost);
        }


        /// <summary>
        /// This is the the stock of the stew. This is where we customize the WFSH we are creating with the behaviours we want
        /// </summary>
        /// <param name="workflowServiceHost"></param>
        private void CustomiseWorkflowHost(WorkflowServiceHost workflowServiceHost)
        {

            //workflowServiceHost.Description.Behaviors.RemoveAll<WorkflowUnhandledExceptionBehavior>();
            // add behaviours that affect the workflow host
            workflowServiceHost.Description.Behaviors.Add(
                new WorkflowUnhandledExceptionBehavior
                {
                    Action = WorkflowUnhandledExceptionAction.Cancel
                });

            workflowServiceHost.Description.Behaviors.RemoveAll<WorkflowIdleBehavior>();
            workflowServiceHost.Description.Behaviors.Add(
                new WorkflowIdleBehavior
                {
                    // Note: Adjust these to flavour
                    TimeToPersist = TimeSpan.FromSeconds(10),
                    TimeToUnload = TimeSpan.FromMinutes(1)
                });

            //Uncomment the following if you need persistence with your workflow. The SQL DB must have right tables etc.
            //Leave a message on this blog post if you need the right scripts for this
            //String connectionString = ConfigurationManager.ConnectionStrings["WorkflowInstanceStore"].ConnectionString;
            //workflowServiceHost.Description.Behaviors.Add(
            //    new SqlWorkflowInstanceStoreBehavior(connectionString)
            //    {
            //        // Go through at all the properties that can be set here and 
            //        // decide which should be set for your uses
            //        InstanceCompletionAction = InstanceCompletionAction.DeleteNothing
            //    });
        }
    }
}